Index: CLFS/master.sh
===================================================================
--- CLFS/master.sh	(revision 1f81129de669195cc4198e52dfc3817ce9fd0575)
+++ CLFS/master.sh	(revision 1838bc7f42e03668f6be04113621e214080b9699)
@@ -1100,10 +1100,10 @@
 	@touch \$@
 
-mk_BLFS_TOOL: mk_SYSTOOLS
-	@\$(call echo_PHASE,Building BLFS-TOOLS); \\
+mk_BLFS_TOOL: create-sbu_du-report
+	@\$(call echo_PHASE,Building BLFS-TOOLS)
 	@if [ "\$(ADD_BLFS_TOOLS)" = "y" ]; then \\
 	  sudo mkdir -p $BUILDDIR$TRACKING_DIR; \\
 	  sudo \$(CHROOT1) "cd \$(SCRIPT_ROOT) && make BLFS_TOOL"; \\
-	fi
+	fi;
 	@touch \$@
 
@@ -1113,4 +1113,13 @@
 CHROOT_JAIL: ${chroottools}${boottools} $testsuitetools $basicsystem  $bootscripttools  $bootabletools
 BLFS_TOOL:   $blfs_tool
+
+
+create-sbu_du-report:  mk_SYSTOOLS
+	@\$(call echo_message, Building)
+	@if [ "\$(ADD_REPORT)" = "y" ]; then \\
+	  ./create-sbu_du-report.sh logs $VERSION; \\
+	  \$(call echo_report,$VERSION-SBU_DU-$(date --iso-8601).report); \\
+	fi;
+	@touch  \$@
 
 do-housekeeping:
@@ -1128,19 +1137,4 @@
 EOF
 ) >> $MKFILE
-
-  # Add SBU-disk_usage report target
-  echo "create-sbu_du-report:" >> $MKFILE
-  if [[ "$REPORT" = "y" ]] ; then
-(
-    cat << EOF
-	@\$(call echo_message, Building)
-	@./create-sbu_du-report.sh logs $VERSION
-	@\$(call echo_report,$VERSION-SBU_DU-$(date --iso-8601).report)
-	@touch  \$@
-
-EOF
-) >> $MKFILE
-  else echo -e "\t@true\n" >> $MKFILE; fi
-
 
 fi
Index: CLFS2/master.sh
===================================================================
--- CLFS2/master.sh	(revision 1f81129de669195cc4198e52dfc3817ce9fd0575)
+++ CLFS2/master.sh	(revision 1838bc7f42e03668f6be04113621e214080b9699)
@@ -468,9 +468,15 @@
 
 SETUP:  $host_prep
-
-LUSER:	$cross_tools $basicsystem $bootscripttools $bootable
-
-ROOT:	$chowning
-
+LUSER:  $cross_tools $basicsystem $bootscripttools $bootable
+ROOT:   $chowning
+
+
+create-sbu_du-report:  ROOT
+	@\$(call echo_message, Building)
+	@if [ "\$(ADD_REPORT)" = "y" ]; then \\
+	  ./create-sbu_du-report.sh logs $VERSION; \\
+	  \$(call echo_report,$VERSION-SBU_DU-$(date --iso-8601).report); \\
+	fi;
+	@touch  \$@
 
 restore-luser-env:
@@ -496,19 +502,4 @@
 ) >> $MKFILE
 
-  # Add SBU-disk_usage report target
-  echo "create-sbu_du-report:" >> $MKFILE
-  if [[ "$REPORT" = "y" ]] ; then
-(
-    cat << EOF
-	@\$(call echo_message, Building)
-	@./create-sbu_du-report.sh logs $VERSION
-	@\$(call echo_report,$VERSION-SBU_DU-$(date --iso-8601).report)
-	@touch  \$@
-
-
-EOF
-) >> $MKFILE
-  else echo -e "\t@true\n\n" >> $MKFILE; fi
-
   # Bring over the items from the Makefile.tmp
   cat $MKFILE.tmp >> $MKFILE
@@ -517,3 +508,2 @@
 
 }
-
Index: CLFS3/master.sh
===================================================================
--- CLFS3/master.sh	(revision 1f81129de669195cc4198e52dfc3817ce9fd0575)
+++ CLFS3/master.sh	(revision 1838bc7f42e03668f6be04113621e214080b9699)
@@ -461,10 +461,17 @@
 	@touch \$@
 
+
 SETUP:  $host_prep
-
 LUSER:	$cross_tools $basicsystem $bootscripttools $bootable
-
 ROOT:	$chowning
 
+
+create-sbu_du-report:  ROOT
+	@\$(call echo_message, Building)
+	@if [ "\$(ADD_REPORT)" = "y" ]; then \\
+	  ./create-sbu_du-report.sh logs $VERSION; \\
+	  \$(call echo_report,$VERSION-SBU_DU-$(date --iso-8601).report); \\
+	fi;
+	@touch  \$@
 
 restore-luser-env:
@@ -490,19 +497,4 @@
 ) >> $MKFILE
 
-  # Add SBU-disk_usage report target
-  echo "create-sbu_du-report:" >> $MKFILE
-  if [[ "$REPORT" = "y" ]] ; then
-(
-    cat << EOF
-	@\$(call echo_message, Building)
-	@./create-sbu_du-report.sh logs $VERSION
-	@\$(call echo_report,$VERSION-SBU_DU-$(date --iso-8601).report)
-	@touch  \$@
-
-
-EOF
-) >> $MKFILE
-  else echo -e "\t@true\n\n" >> $MKFILE; fi
-
   # Bring over the items from the Makefile.tmp
   cat $MKFILE.tmp >> $MKFILE
Index: Config.in
===================================================================
--- Config.in	(revision 1f81129de669195cc4198e52dfc3817ce9fd0575)
+++ Config.in	(revision 1838bc7f42e03668f6be04113621e214080b9699)
@@ -291,6 +291,5 @@
 		bool	"Add blfs-tool support"
 		default	n
-#		depends on !BOOK_BLFS
-		depends on BOOK_LFS || BOOK_CLFS
+		depends on !BOOK_BLFS && !BOOK_CLFS2 && !BOOK_CLFS3
 		help
 			#--- Activating this option additional packages needed to
Index: HLFS/master.sh
===================================================================
--- HLFS/master.sh	(revision 1f81129de669195cc4198e52dfc3817ce9fd0575)
+++ HLFS/master.sh	(revision 1838bc7f42e03668f6be04113621e214080b9699)
@@ -523,5 +523,5 @@
   cat << EOF
 
-all:	ck_UID mk_SETUP mk_LUSER mk_SUDO mk_CHROOT mk_BOOT create-sbu_du-report
+all:	ck_UID mk_SETUP mk_LUSER mk_SUDO mk_CHROOT mk_BOOT create-sbu_du-report mk_BLFS_TOOL
 	@sudo make do-housekeeping
 	@\$(call echo_finished,$VERSION)
@@ -567,15 +567,28 @@
 	@touch \$@
 
-
-SETUP:	$chapter3
-
-LUSER:	$chapter5
-
-SUDO:	060-kernfs 062-changingowner
-
-CHROOT:	$chapter6
-
-BOOT:	$chapter7
-
+mk_BLFS_TOOL: create-sbu_du-report
+	@\$(call echo_PHASE,Building BLFS-TOOLS)
+	@if [ "\$(ADD_BLFS_TOOLS)" = "y" ]; then \\
+	  sudo mkdir -p $BUILDDIR$TRACKING_DIR; \\
+	  sudo \$(CHROOT2) "cd \$(SCRIPT_ROOT) && make BLFS_TOOL"; \\
+	fi;
+	@touch \$@
+
+
+SETUP:     $chapter3
+LUSER:     $chapter5
+SUDO:      060-kernfs 062-changingowner
+CHROOT:    $chapter6
+BOOT:      $chapter7
+BLFS_TOOL: $blfs_tool
+
+
+create-sbu_du-report:  mk_BOOT
+	@\$(call echo_message, Building)
+	@if [ "\$(ADD_REPORT)" = "y" ]; then \\
+	  ./create-sbu_du-report.sh logs $VERSION; \\
+	  \$(call echo_report,$VERSION-SBU_DU-$(date --iso-8601).report); \\
+	fi;
+	@touch  \$@
 
 restore-luser-env:
@@ -609,19 +622,4 @@
 ) >> $MKFILE
 
-  # Add SBU-disk_usage report target
-  echo "create-sbu_du-report:" >> $MKFILE
-  if [[ "$REPORT" = "y" ]] ; then
-(
-    cat << EOF
-	@\$(call echo_message, Building)
-	@./create-sbu_du-report.sh logs $VERSION
-	@\$(call echo_report,$VERSION-SBU_DU-$(date --iso-8601).report)
-	@touch  \$@
-
-
-EOF
-) >> $MKFILE
-  else echo -e "\t@true\n\n" >> $MKFILE; fi
-
   # Bring over the items from the Makefile.tmp
   cat $MKFILE.tmp >> $MKFILE
Index: LFS/master.sh
===================================================================
--- LFS/master.sh	(revision 1f81129de669195cc4198e52dfc3817ce9fd0575)
+++ LFS/master.sh	(revision 1838bc7f42e03668f6be04113621e214080b9699)
@@ -459,15 +459,28 @@
 	@touch \$@
 
-
-SETUP:	$chapter4
-
-LUSER:	$chapter5
-
-SUDO:	057-changingowner 059-kernfs
-
-CHROOT:	$chapter6
-
-BOOT:	$chapter789
-
+mk_BLFS_TOOL: create-sbu_du-report
+	@\$(call echo_PHASE,Building BLFS-TOOLS)
+	@if [ "\$(ADD_BLFS_TOOLS)" = "y" ]; then \\
+	  sudo mkdir -p $BUILDDIR$TRACKING_DIR; \\
+	  sudo \$(CHROOT2) "cd \$(SCRIPT_ROOT) && make BLFS_TOOL"; \\
+	fi;
+	@touch \$@
+
+
+SETUP:     $chapter4
+LUSER:     $chapter5
+SUDO:      057-changingowner 059-kernfs
+CHROOT:    $chapter6
+BOOT:      $chapter789
+BLFS_TOOL: $blfs_tool
+
+
+create-sbu_du-report:  mk_BOOT
+	@\$(call echo_message, Building)
+	@if [ "\$(ADD_REPORT)" = "y" ]; then \\
+	  ./create-sbu_du-report.sh logs $VERSION; \\
+	  \$(call echo_report,$VERSION-SBU_DU-$(date --iso-8601).report); \\
+	fi;
+	@touch  \$@
 
 restore-luser-env:
@@ -500,36 +513,4 @@
 ) >> $MKFILE
 
-  # Add SBU-disk_usage report target
-  echo "create-sbu_du-report:" >> $MKFILE
-  if [[ "$REPORT" = "y" ]] ; then
-(
-    cat << EOF
-	@\$(call echo_message, Building)
-	@./create-sbu_du-report.sh logs $VERSION
-	@\$(call echo_report,$VERSION-SBU_DU-$(date --iso-8601).report)
-	@touch  \$@
-
-
-EOF
-) >> $MKFILE
-  else echo -e "\t@true\n\n" >> $MKFILE; fi
-
-  # Add BLFS_TOOL targets
-  echo "mk_BLFS_TOOL:" >> $MKFILE
-  if [[ "$BLFS_TOOL" = "y" ]] ; then
-(
-    cat << EOF
-	@\$(call echo_CHROOT_request)
-	@ sudo mkdir -p $BUILDDIR$TRACKING_DIR
-	@( sudo \$(CHROOT2) "cd \$(SCRIPT_ROOT) && make BLFS_TOOL")
-	@touch \$@
-
-BLFS_TOOL:  $blfs_tool
-
-
-EOF
-) >> $MKFILE
-  else echo -e "\t@true\n\n" >> $MKFILE; fi
-
   # Bring over the items from the Makefile.tmp
   cat $MKFILE.tmp >> $MKFILE
Index: README
===================================================================
--- README	(revision 1f81129de669195cc4198e52dfc3817ce9fd0575)
+++ README	(revision 1838bc7f42e03668f6be04113621e214080b9699)
@@ -82,5 +82,8 @@
 
      For books that support it, there is an option to install blfs-tool and its
-     dependendencies on the final system.
+     dependendencies on the final system. The pre-made build dependencies
+     scripts has been written thinking on a LFS build. For CLFS and HLFS
+     builds you may need to adjust that scripts, that are found into the
+     common/blfs-tool-deps directory in the jhalfs sources tree.
 
      After booting the new xLFS system some steps are needed to finish
Index: common/libs/func_wrt_Makefile
===================================================================
--- common/libs/func_wrt_Makefile	(revision 1f81129de669195cc4198e52dfc3817ce9fd0575)
+++ common/libs/func_wrt_Makefile	(revision 1838bc7f42e03668f6be04113621e214080b9699)
@@ -22,5 +22,4 @@
 LGROUP         = $LGROUP
 SCRIPT_ROOT    = $SCRIPT_ROOT
-ADD_BLFS_TOOLS = $BLFS_TOOL
 
 BASEDIR        = \$(MOUNT_PT)
@@ -38,4 +37,8 @@
 PRT_DU         = echo -e "\nKB: \`du -skx --exclude=\$(SCRIPT_ROOT) --exclude=lost+found \$(MOUNT_PT) \`\n"
 PRT_DU_CR      = echo -e "\nKB: \`du -skx --exclude=\$(SCRIPT_ROOT) --exclude=lost+found / \`\n"
+
+ADD_REPORT     = $REPORT
+ADD_BLFS_TOOLS = $BLFS_TOOL
+
 
 export PATH := \${PATH}:/usr/sbin